﻿ReagentHelper2 = LibStub("AceAddon-3.0"):NewAddon("ReagentHelper2", "AceEvent-3.0", "AceConsole-3.0")
local AceConfig = LibStub("AceConfigDialog-3.0");
--local L = LibStub("AceLocale-3.0"):GetLocale("ReagentHelper2");
local BabbleClass = LibStub("LibBabble-Class-3.0"):GetLookupTable();
local BabbleInventory = LibStub("LibBabble-Inventory-3.0"):GetLookupTable();

local ToolTipList = {};

function ReagentHelper2:OnInitialize()
	ReagentHelper2:RegisterEvent("ADDON_LOADED", "AddonLoaded")
end

function ReagentHelper2:AddonLoaded()
	if (arg1 == "ReagentHelper2") then
		GameTooltip:HookScript("OnGetItem", function () ReagentHelper2:ModifyItemTooltip(this) end)
		GameTooltip:HookScript("OnSetAuctionCompareItem", function () ReagentHelper2:ModifyItemTooltip(this) end)
		GameTooltip:HookScript("OnSetAuctionItem", function () ReagentHelper2:ModifyItemTooltip(this) end)
		GameTooltip:HookScript("OnSetAuctionSellItem", function () ReagentHelper2:ModifyItemTooltip(this) end)
		GameTooltip:HookScript("OnSetBuybackItem", function () ReagentHelper2:ModifyItemTooltip(this) end)
		GameTooltip:HookScript("OnSetCraftItem", function () ReagentHelper2:ModifyItemTooltip(this) end)
		GameTooltip:HookScript("OnSetGuildBankItem", function () ReagentHelper2:ModifyItemTooltip(this) end)
		GameTooltip:HookScript("OnSetInboxItem", function () ReagentHelper2:ModifyItemTooltip(this) end)
		GameTooltip:HookScript("OnSetInventoryItem", function () ReagentHelper2:ModifyItemTooltip(this) end)
		GameTooltip:HookScript("OnSetLootItem", function () ReagentHelper2:ModifyItemTooltip(this) end)
		GameTooltip:HookScript("OnSetLootRollItem", function () ReagentHelper2:ModifyItemTooltip(this) end)
		GameTooltip:HookScript("OnSetMerchantCompareItem", function () ReagentHelper2:ModifyItemTooltip(this) end)
		GameTooltip:HookScript("OnSetMerchantItem", function () ReagentHelper2:ModifyItemTooltip(this) end)
		--GameTooltip:HookScript("OnQuestItem", function () ReagentHelper2:ModifyItemTooltip(this) end)
		GameTooltip:HookScript("OnSetQuestLogItem", function () ReagentHelper2:ModifyItemTooltip(this) end)
		GameTooltip:HookScript("OnSetSendMailItem", function () ReagentHelper2:ModifyItemTooltip(this) end)
		GameTooltip:HookScript("OnSetTradePlayerItem", function () ReagentHelper2:ModifyItemTooltip(this) end)
		GameTooltip:HookScript("OnSetTradeSkillItem", function () ReagentHelper2:ModifyItemTooltip(this) end)
		GameTooltip:HookScript("OnSetTradeTargetItem", function () ReagentHelper2:ModifyItemTooltip(this) end)
	end
end

function ReagentHelper2:ModifyItemTooltip(ToolTip)
	ReagentHelper2:Print("test");
	local itemName, ItemLink = ToolTip:GetItem();
	ReagentHelper2:SearchProffReagents(itemName);
	table.sort(ToolTipList);
	for i = 0, #(ToolTipList), 1 do
		ToolTip:AddLine(ToolTipList[i], true);
	end
end

function ReagentHelper2:SearchProffReagents(ItemName)
	table.wipe(ToolTipList);
	for k, v in pairs(ReagentHelper2.Alchemy) do
		if (string.Lower(ItemName) == string.Lower(v)) then
			table.insert(ToolTipList, BabbleInventory["Alchemy"]);
		end
	end
	for k, v in pairs(ReagentHelper2.Blacksmithing) do
		if (string.Lower(ItemName) == string.Lower(v)) then
			table.insert(ToolTipList, BabbleInventory["Blacksmithing"]);
		end
	end
	for k, v in pairs(ReagentHelper2.Cooking) do
		if (string.Lower(ItemName) == string.Lower(v)) then
			table.insert(ToolTipList, BabbleInventory["Cooking"]);
		end
	end
	for k, v in pairs(ReagentHelper2.Enchanting) do
		if (string.Lower(ItemName) == string.Lower(v)) then
			table.insert(ToolTipList, BabbleInventory["Enchanting"]);
		end
	end
	for k, v in pairs(ReagentHelper2.Engineering) do
		if (string.Lower(ItemName) == string.Lower(v)) then
			table.insert(ToolTipList, BabbleInventory["Engineering"]);
		end
	end
	for k, v in pairs(ReagentHelper2.FirstAid) do
		if (string.Lower(ItemName) == string.Lower(v)) then
			table.insert(ToolTipList, BabbleInventory["First Aid"]);
		end
	end
	for k, v in pairs(ReagentHelper2.Inscription) do
		if (string.Lower(ItemName) == string.Lower(v)) then
			table.insert(ToolTipList, BabbleInventory["Inscription"]);
		end
	end
	for k, v in pairs(ReagentHelper2.Jewelcrafting) do
		if (string.Lower(ItemName) == string.Lower(v)) then
			table.insert(ToolTipList, BabbleInventory["Jewelcrafting"]);
		end
	end
	for k, v in pairs(ReagentHelper2.Leatherworkingy) do
		if (string.Lower(ItemName) == string.Lower(v)) then
			table.insert(ToolTipList, BabbleInventory["Leatherworking"]);
		end
	end
	for k, v in pairs(ReagentHelper2.Mining) do
		if (string.Lower(ItemName) == string.Lower(v)) then
			table.insert(ToolTipList, BabbleInventory["Mining"]);
		end
	end
	for k, v in pairs(ReagentHelper2.Tailoring) do
		if (string.Lower(ItemName) == string.Lower(v)) then
			table.insert(ToolTipList, BabbleInventory["Tailoring"]);
		end
	end
	
	for k, v in pairs(ReagentHelper2.Mage) do
		if (string.Lower(ItemName) == string.Lower(v)) then
			table.insert(ToolTipList, BabbleClass["Mage"]);
		end
	end
	for k, v in pairs(ReagentHelper2.Priest) do
		if (string.Lower(ItemName) == string.Lower(v)) then
			table.insert(ToolTipList, BabbleClass["Priest"]);
		end
	end
	for k, v in pairs(ReagentHelper2.Warlock) do
		if (string.Lower(ItemName) == string.Lower(v)) then
			table.insert(ToolTipList, BabbleClass["Warlock"]);
		end
	end
	for k, v in pairs(ReagentHelper2.Druid) do
		if (string.Lower(ItemName) == string.Lower(v)) then
			table.insert(ToolTipList, BabbleClass["Druid"]);
		end
	end
	for k, v in pairs(ReagentHelper2.Shaman) do
		if (string.Lower(ItemName) == string.Lower(v)) then
			table.insert(ToolTipList, BabbleClass["Shaman"]);
		end
	end
	for k, v in pairs(ReagentHelper2.Paladin) do
		if (string.Lower(ItemName) == string.Lower(v)) then
			table.insert(ToolTipList, BabbleClass["Paladin"]);
		end
	end
end